import { HttpConfig } from "../types";
import { CacheManager, CacheManagerOption } from "./CacheManager";
export type CookieCacheManagerOption<T1 = any, T2 = any> = {
    bucket?: {
        cookie: string;
    };
} & CacheManagerOption<T1, T2>;
export declare class CookieCacheManager<T> implements CacheManager<T> {
    private _usedSpace;
    private _availableSpace;
    private _options;
    protected static instance: CookieCacheManager<any>;
    constructor(options?: CookieCacheManagerOption);
    static getInstance(options?: CookieCacheManagerOption): CookieCacheManager<any>;
    usedSpace(): number;
    availableSpace(): number;
    calculateSpace(configOrKey: string | HttpConfig, value: T): number;
    has(configOrKey: string | HttpConfig): boolean;
    get(configOrKey: string | HttpConfig): {
        date: Date;
        value: T;
    } | undefined;
    getValue(configOrKey: string | HttpConfig): T | undefined;
    set(configOrKey: string | HttpConfig, value: T): void;
    remove(configOrKey: string | HttpConfig): void;
    clear(): void;
    find(cond: (key: string) => boolean): string[];
    private _resolve;
}
