import { HttpConfig } from "../types";
import { CacheManager, CacheManagerOption } from "./CacheManager";
export type MapCacheManagerOption<T1 = any, T2 = any> = {
    maxEntries?: number;
} & CacheManagerOption<T1, T2>;
export declare class MapCacheManager<T> implements CacheManager<T> {
    private _entriesCount;
    private _options;
    protected static instance: MapCacheManager<any>;
    constructor(options?: MapCacheManagerOption);
    static getInstance(options?: MapCacheManagerOption): MapCacheManager<any>;
    usedSpace(): number;
    availableSpace(): number;
    calculateSpace(_: string | HttpConfig, __: T): number;
    has(configOrKey: string | HttpConfig): boolean;
    get(configOrKey: string | HttpConfig): {
        date: Date;
        value: T;
    } | undefined;
    getValue(configOrKey: string | HttpConfig): T | undefined;
    set(configOrKey: string | HttpConfig, value: T): void;
    remove(configOrKey: string | HttpConfig): void;
    clear(): void;
    find(cond: (key: string) => boolean): string[];
    private _resolve;
}
