import { HttpConfig } from "../types";
import { CacheManager, CacheManagerOption } from "./CacheManager";
export type StorageCacheManagerOption<T1 = any, T2 = any> = {
    bucket?: Storage;
} & CacheManagerOption<T1, T2>;
export declare class StorageCacheManager<T> implements CacheManager<T> {
    private _usedSpace;
    private _availableSpace;
    private _options;
    constructor(bucket: Storage, options?: StorageCacheManagerOption);
    usedSpace(): number;
    availableSpace(): number;
    calculateSpace(configOrKey: string | HttpConfig, value: T): number;
    has(configOrKey: string | HttpConfig): boolean;
    get(configOrKey: string | HttpConfig): {
        date: Date;
        value: T;
    } | undefined;
    getValue(configOrKey: string | HttpConfig): T | undefined;
    set(configOrKey: string | HttpConfig, value: T): void;
    remove(configOrKey: string | HttpConfig): void;
    clear(): void;
    find(cond: (key: string) => boolean): string[];
    private _resolve;
}
