"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = wsConnector;
const core_1 = require("../../core");
const node_classes_1 = __importDefault(require("../../helper/node_classes"));
function wsConnector(config) {
    if (config.dynamicConfig)
        config = config.dynamicConfig(config);
    const socket = new node_classes_1.default.WebSocket(config.url, config.protocol);
    socket.addEventListener('open', (e) => { var _a; return (_a = config.interceptor) === null || _a === void 0 ? void 0 : _a.invoke(core_1.HandlerType.WS_OPEN, config, e); });
    socket.addEventListener('close', (e) => { var _a; return (_a = config.interceptor) === null || _a === void 0 ? void 0 : _a.invoke(core_1.HandlerType.WS_CLOSE, config, e); });
    socket.addEventListener('error', (e) => { var _a; return (_a = config.interceptor) === null || _a === void 0 ? void 0 : _a.invoke(core_1.HandlerType.WS_ERROR, config, e); });
    socket.addEventListener('message', (e) => { var _a; return (_a = config.interceptor) === null || _a === void 0 ? void 0 : _a.invoke(core_1.HandlerType.WS_MESSAGE, config, e); });
    socket.name = "wsConnector";
    return socket;
}
module.exports = wsConnector;
