import { Config, HttpConfig } from "../types";
import { CacheManager } from "../cachemanager";
export interface IHttp {
    getConfig(): HttpConfig;
    getUrl(config: Config): string;
    queueRequest(config: HttpConfig): void;
    get(url: string, config?: HttpConfig): Promise<any>;
    head(url: string, config?: HttpConfig): Promise<any>;
    retryRequests(cache?: CacheManager<any>): Promise<any>;
    delete(url: string, config?: HttpConfig): Promise<any>;
    options(url: string, config?: HttpConfig): Promise<any>;
    updateConfig(newConfig: HttpConfig, merge?: boolean): void;
    put(url: string, data: any, config?: HttpConfig): Promise<any>;
    post(url: string, data: any, config?: HttpConfig): Promise<any>;
    patch(url: string, data: any, config?: HttpConfig): Promise<any>;
    request(urlOrConfig: string | HttpConfig, config?: HttpConfig): Promise<any>;
}
export declare class Http implements IHttp {
    private _baseConfig;
    protected static instance: Http;
    private _queueRebuilds;
    private _nonSerializable;
    constructor(baseConfig?: HttpConfig);
    static getInstance(baseConfig?: HttpConfig): Http;
    getConfig(): HttpConfig;
    updateConfig(newConfig: HttpConfig, merge?: boolean): void;
    getUrl(config: Config): string;
    request(urlOrConfig: string | HttpConfig, config?: HttpConfig): Promise<any>;
    get(url: string, config?: HttpConfig): Promise<any>;
    head(url: string, config?: HttpConfig): Promise<any>;
    delete(url: string, config?: HttpConfig): Promise<any>;
    options(url: string, config?: HttpConfig): Promise<any>;
    put(url: string, data: any, config?: HttpConfig): Promise<any>;
    post(url: string, data: any, config?: HttpConfig): Promise<any>;
    patch(url: string, data: any, config?: HttpConfig): Promise<any>;
    queueRequest(config: HttpConfig): void;
    retryRequests(cacheManager?: CacheManager<any>): Promise<any>;
    private _registerCacheInterceptors;
}
