import { Config } from "../types";
import { KyofuucObject } from "../helper";
export declare enum HandlerType {
    CUSTOM = "CUSTOM",
    WS_OPEN = "WS_OPEN",
    WS_CLOSE = "WS_CLOSE",
    WS_ERROR = "WS_ERROR",
    WS_MESSAGE = "WS_MESSAGE",
    WS_STATE_CHANGE = "WS_STATE_CHANGE",
    HTTP_PRE_REQUEST = "HTTP_PRE_REQUEST",
    HTTP_POST_REQUEST = "HTTP_POST_REQUEST",
    HTTP_PRE_RESPONSE = "HTTP_PRE_RESPONSE",
    HTTP_POST_RESPONSE = "HTTP_POST_RESPONSE",
    HTTP_REQUEST_MAXIMUM_REDIRECTS_REACHED = "HTTP_REQUEST_MAXIMUM_REDIRECTS_REACHED"
}
export type HandlerCallback = (config?: Config, options?: KyofuucObject<any>, response?: any) => KyofuucObject<any> | void;
export interface Handler {
    type: HandlerType;
    cb: HandlerCallback;
    options?: KyofuucObject<any>;
    when?: (config?: Config) => boolean;
}
export declare class Interceptor {
    private _count;
    private _handlers;
    private _reverse_handler_type_map;
    constructor(interceptors?: Interceptor[]);
    count(): number;
    register(handler: Handler): string;
    unregister(key: string): void;
    purge(): void;
    registers(interceptors: Interceptor[]): string[];
    handler(key: string): Handler | undefined;
    handlers(type: HandlerType): Handler[];
    invoke(type: HandlerType, config?: Config, response?: any): KyofuucObject<any>[];
    registerPreRequest(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerPostRequest(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerPreResponse(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerPostResponse(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerOnWsOpen(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerOnWsClose(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerOnWsError(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerOnWsMessage(cb: HandlerCallback, options?: KyofuucObject<any>): string;
    registerOnWsStateChange(cb: HandlerCallback, options?: KyofuucObject<any>): string;
}
