import zlib from "zlib";
import { Stream } from "stream";
import { KyofuucObject } from "../helper";
export declare const CompressionType: {
    GZIP: string;
    UNZIP: string;
    BROTLI: string;
    GUNZIP: string;
    INFLATE: string;
    DEFLATE: string;
    COMPRESS: string;
};
export type Flow = "compress" | "decompress";
export type CompressionTransformer = () => Stream;
export declare function gzipCompressionTransformer(): zlib.Gzip;
export declare function inflateCompressionTransformer(): zlib.Inflate;
export declare function deflateCompressionTransformer(): zlib.Unzip;
export declare function gunzipCompressionTransformer(): zlib.Gunzip;
export declare function brotliCompressionTransformer(): zlib.BrotliCompress;
export declare function brotliDecompressionTransformer(): zlib.BrotliDecompress;
export declare const CompressionProcessor: {
    _RegisteredCompressTransformers: KyofuucObject<CompressionTransformer>;
    _RegisteredDecompressTransformers: KyofuucObject<CompressionTransformer>;
    register(type: string, flow: Flow, transformer: CompressionTransformer): void;
    unregister(type: string, flow: Flow): void;
    transform(type: string, flow: Flow): Stream;
};
